/*
linphone
Copyright (C) 2000  Simon MORLAT (simon.morlat@free.fr)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* this file implements a dummy souncard that would have its input connected to its output.
This is for testing purposes, for example for use with 'sipomatic', the answering machine*/

#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <pthread.h>
#include "loopback.h"

static char *buffer1=NULL;
static unsigned int ts=0,real_ts=0;
static int bufsize;
static int blocksize=160*2; //20 ms
//static pthread_mutex_t mutex=PTHREAD_MUTEX_INITIALIZER

void alarm_handler(int signum);

int open_dsp_loopback(int rate,int channel,int bits,int bsize)
{
	
	if (bsize<=0) return(-EINVAL);
	if ((bsize>180*2)|| (bsize<150*2)) return(-EOPNOTSUPP);  /*we can simulate approx 20 ms reads: REVISIT*/
	buffer1=calloc(bsize,sizeof(char));
	ts=0;
	real_ts=0;
	bufsize=bsize;
	
	return(0);
}

int set_source_loopback(char source)
{
	return(0);
}

int set_in_level_loopback(int a)
{
	return(0);
}

int set_out_level_loopback(int a)
{
	return(0);
}

int close_dsp_loopback()
{
	if ((buffer1==NULL)) return(-EFAULT);
	free(buffer1);
	buffer1=NULL;
	return(0);
}

char *get_read_loopback_buffer()
{
	struct itimerval ival;
	
	ts+=bufsize;
	while (ts-real_ts>=blocksize)
	{  /* sleep 20ms to simulate a read on the soundcard*/
		real_ts+=blocksize;
		ival.it_value.tv_sec=0;
		ival.it_value.tv_usec=20000;
		ival.it_interval.tv_sec=0;
		ival.it_interval.tv_usec=20000;
		setitimer(ITIMER_REAL,&ival,NULL);
		signal(SIGALRM,&alarm_handler);
		/* then we sleep until we are woken up by the alarm*/
		sleep(2);
	}
	
	return(buffer1);
}


char *get_write_loopback_buffer()
{
	return(buffer1);
}


void alarm_handler(int signum)
{
	
}


