/***************************************************************************
                          rtprecept.c - test program to receive a file
                             -------------------
    begin                : ven mar  30
    copyright            : (C) 2001 by Simon MORLAT
    email                : simon.morlat@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "rtp.h"
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <sys/time.h>

void tick_handler(int signal);

int cond=1;
void stopfunc(int signum);
void setsignal();
FILE *dbgfile,*output;
RtpSession *handle;

void stopfunc(int signum)
{
    cond=0;
}

int main(int argc, char *argv[])
{
  int err;

  rtp_params_t params;
	
  struct itimerval ival;

  setsignal();
  signal(SIGINT,&stopfunc);
  handle=rtp_create_session(RTP_RECV);
  if (handle==NULL)
    {
      printf("rtp_create_session failed.\n");
      return(-1);
    }
  bzero(&params,sizeof(params));
  params.profile=4;
  params.rtp_loc_addr="0.0.0.0";
  params.rtp_loc_port=7000;
  params.jitt_comp=3;
  params.stacksize=20;
  params.redundancy=0;

  err=rtp_set_parameters(handle,&params);
  if (err<0)
    {
      printf("rtp_set_parameters : %s (%i)\n",rtp_perror(err),err);
      return(-1);
    }
  dbgfile=fopen("rtp_debug","wb");
  output=fopen("/tmp/infile","wb");
  if (dbgfile==NULL) fprintf(stderr,"Fail to open file.\n");
  rtp_debug(handle,dbgfile);

	ival.it_value.tv_sec=0;
	ival.it_value.tv_usec=20000;
	ival.it_interval.tv_sec=0;
	ival.it_interval.tv_usec=20000;
	setitimer(ITIMER_REAL,&ival,NULL);

  while (cond)
    {
      sleep(1);

    }
  err=rtp_destroy_session(handle);
  fclose(dbgfile);
  fclose(output);
  	printf("Stop.\n");
  return(0);
}

void tick_handler(int signal)
{
	int err,i,r=1;
	unsigned char buffer[512];
	int32_t *tmp;
	
	err=rtp_recv(handle,buffer,7);
	fwrite(buffer,7,1,output);
	
  	if (err>0) fprintf(stderr,"Packet received. (%i bytes)\n",err);
  	else fprintf(stderr,"No packets availlable (%i).\n",err);
	if (cond) setsignal();
}

void setsignal()
{
	signal(SIGALRM,&tick_handler);
}
