/***************************************************************************
                          rtpsender.c - test program to send a file
                             -------------------
    begin                : ven mar  30
    copyright            : (C) 2001 by Simon MORLAT
    email                : simon.morlat@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "rtp.h"
#include <sys/time.h>
#include <signal.h>

FILE *dbgfile,*input;
RtpSession *handle;
rtp_params_t params;
void tick_handler(int signal);
void setsignal();
void tick_handler2(int signal);

int main(int argc, char *argv[])
{
  int err;
	struct itimerval ival;


  setsignal();
  handle=rtp_create_session(RTP_SEND);
  if (handle==NULL)
    {
      fprintf(stderr,"rtp_create_session failed.\n");
      return(-1);
    }
  memset(&params,0,sizeof(params));
  params.profile=4;
  params.rtp_loc_addr="0.0.0.0";
  params.rtp_loc_port=6000;
  params.rtp_rem_addr="127.0.0.1";
  params.rtp_rem_port=7000;
  params.jitt_comp=1;
  params.stacksize=20;
  params.ssrc=8888;
  params.redundancy=0;

  err=rtp_set_parameters(handle,&params);
  if (err<0)
    {
      fprintf(stderr,"rtp_set_parameters : %s (%i)\n",rtp_perror(err),err);
      return(-1);
    }

  input=fopen("/tmp/dam9.bits","r");
  if (input==NULL) fprintf(stderr,"Fail to open file.\n");

	ival.it_value.tv_sec=0;
	ival.it_value.tv_usec=20000;
	ival.it_interval.tv_sec=0;
	ival.it_interval.tv_usec=20000;
	setitimer(ITIMER_REAL,&ival,NULL);

  while (1) sleep(1);
  /*
  cond=1;
  while(cond)
    {
      usleep(15000);
      cond=fread(buffer,160,1,input);
      err=rtp_send(handle,buffer,33);
      fprintf(stderr,"Packet sended. (%i bytes)\n",err);
      
    }
  */
  err=rtp_destroy_session(handle);
  fclose(input);
  fclose(dbgfile);
  return(0);
}

void tick_handler(int signal)
{
	int err,i,r=1;
	unsigned char buffer[512];
	static int tmp=0;
	
	if (tmp<5)
	{
		/*err=fread(buffer,1,7,input);*/
		for (i=0;i<7;i++)
		{
			buffer[i]=fgetc(input);
		}
		err=rtp_send(handle,buffer,7);
  		printf("Packet sended. (%i bytes)\n",err);
  	}
  	else
  	{
  		printf("Packet NOT sended.\n");
  		err=rtp_send(handle,buffer,0);
  		if (tmp==10) tmp=-1;
  	}
  	tmp++;
	setsignal();
}

void tick_handler2(int signal)
{
	int err,i=0;
	static int r=0;
	unsigned char buffer[512];
	static int tmp=0;
	
	if (tmp==0)
	{
		/* send 3 packets */
		for (i=0;i<3;i++)
		{
			r++;
			err=fread(buffer,1,7,input);
			if (r!=30) err=rtp_send(handle,buffer,7);
			else
			{
				printf("lost packet sended!\n");
				err=rtp_send(handle,buffer,0);
			}
		}
  		printf("3 packets sended. (%i bytes)\n",err);
  	}
  	else
  	{
  		printf("NO Packets sended.\n");
  		/*err=rtp_send(handle,buffer,0);*/
  		if (tmp==2) tmp=-1;
  	}
  	tmp++;
	setsignal();
}

void setsignal()
{
	signal(SIGALRM,&tick_handler2);
}
