#ifndef RTPPORT_H
#define RTPPORT_H

#include <sys/types.h>

/* integer types */
typedef  uint16_t guint16;
typedef  uint32_t guint32;
typedef  unsigned int guint;
typedef  int gint;
typedef  char gchar;
typedef unsigned char guint8;


#ifdef TARGET_IS_HPUXKERNEL

/* REVISIT: are all HP-UX kernel big endian ? */
#define htons(x)	(x)
#define htonl(x)	(x)
#define ntohs(x)	(x)
#define ntohl(x)	(x)

#define memcpy(dest,src,size)	bcopy((src),(dest),(size))
#define memset(p,v,n)		for (int _i=0;_i<(n);_i++) ((char*)(p))[_i]=(v)

#else
#include <stdlib.h>
#endif



#ifndef TARGET_IS_HPUXKERNEL
/* memory allocation functions */
#define g_malloc(sz)  malloc((sz))
#define g_realloc(p,sz) realloc((p),(sz))
#define g_free(p)    free((p))

#else

#define g_malloc(sz)  kmem_alloc(sz)
#define g_free(p)     kmem_free(p)

#endif /*TARGET_IS_HPUXKERNEL */

/*misc*/
#define g_return_if_fail(expr) if (!(expr)) {printf("%s:%i- assertion expr failed\n",__FILE__,__LINE__); return;}
#define g_return_val_if_fail(expr,ret) if (!(expr)) {printf("%s:%i- assertion expr failed\n",__FILE__,__LINE__); return (ret);}
#define g_message printf
#define g_warning printf


#endif /*RTPPORT_H*/

