/*
  The oRTP LinPhone RTP library intends to provide basics for a RTP stack.
  Copyright (C) 2001  Simon MORLAT simon.morlat@linphone.org

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef STR_UTILS_H
#define STR_UTILS_H

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#ifdef HAVE_GLIB
#include <glib.h>
#else
#include "rtpport.h"
#endif

typedef struct msgb
{
	struct msgb *b_prev;
	struct msgb *b_next;
	struct msgb *b_cont;
	struct datab *b_datap;
	char *b_rptr;
	char *b_wptr;
} mblk_t;

typedef struct datab
{
	void *db_base;
	void *db_lim;
	guint ref_count;
} dblk_t;

typedef struct _queue
{
	mblk_t *q_first;
	mblk_t *q_last;
	guint  q_count;
} queue_t;

void putq(queue_t *q, mblk_t *m);
mblk_t * getq(queue_t *q);

void insq(queue_t *q,mblk_t *emp, mblk_t *mp);

/* allocates a mblk_t, that points to a datab_t, that points to a buffer of size size. */
mblk_t *allocb(gint size,gint unused);
#define BPRI_MED 0

/* frees a mblk_t, and if the datab ref_count is 0, frees it and the buffer too */
void freeb(mblk_t *m);

/* frees recursively (follow b_cont) a mblk_t, and if the datab
ref_count is 0, frees it and the buffer too */
void freemsg(mblk_t *mp);

/* duplicates a mblk_t */
mblk_t *dupb(mblk_t *m);

/* remove and free all messages in the q */
#define FLUSHALL 0
void flushq(queue_t *q, int how);
#endif
