/*
  The osipua library is a library based on oSIP that implements CallLeg and User Agent
  level.
  Copyright (C) 2001  Simon MORLAT simon.morlat@free.fr
  											Aymeric MOIZARD jack@atosc.org
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "mediadesc.h"
#include "osipua.h"

MediaDesc *media_desc_new(int type)
{
	MediaDesc *md;
	md=(MediaDesc*)smalloc(sizeof(MediaDesc));
	memset(md,0,sizeof(MediaDesc));
	md->type=type;
	md->profile_list=smalloc(sizeof(list_t));
	list_init(md->profile_list);
	return(md);
}

MediaDesc *media_desc_new_from_char(char *list, int type)
{
	int err=2;
	int *profile;
	int prof=0,c;
	char *p=list;
	MediaDesc *md;
	
	md=(MediaDesc*)smalloc(sizeof(MediaDesc));
	md->type=type;
	md->profile_list=smalloc(sizeof(list_t));
	list_init(md->profile_list);
	while(err>0)
	{
		
		err=sscanf(p,"%i %n",&prof,&c);
		//printf("scanning..%i \n",err);
		if (err>0)
		{
			profile=(int*)smalloc(sizeof(int));
			profile[0]=prof;
			//printf("prof=%i c=%i   %s\n",prof,c,p);
			list_add(md->profile_list,profile,-1);
			p+=c;
			if (c==0) err=0;
		}
	}
	return(md);
}

MediaDesc * media_desc_new_from_mediad(mediad_t *mediad)
{
	int c;
	char mtype[10];
	char *p;
	int type=0,port;
	MediaDesc *md;
	
	sscanf(mediad->m,"%s %i %*s %n",mtype,&port,&c);
	/*printf("*****************remote port = %i\n",port);*/
	p=mediad->m+c;
	if (strcasecmp(mtype,"audio")==0) type=STREAM_AUDIO;
	else if (strcasecmp(mtype,"video")==0) type=STREAM_VIDEO;
	else osip_trace(TRACE_LEVEL2,("Unknow stream type in mediad.\n"));
	
	md=media_desc_new_from_char(p, type);
	md->rem_port=port;
	return(md);
}
	
void media_desc_append_profile(MediaDesc *md, int profile)
{
	int *prof;
	if (md->profile_list==NULL) return;
	
	prof=(int*)smalloc(sizeof(int));
	prof[0]=profile;
	list_add(md->profile_list,prof,-1);
}

char * media_desc_profiles_2char(MediaDesc *md)
{
	int i,c;
	int *prof;
	char *str,*p;
	list_t *proflist=md->profile_list;
	
	if (proflist==NULL) return(NULL);
	p=str=(char*)smalloc((5*proflist->nb_elt)+1);
	for (i=0;i<proflist->nb_elt;i++)
	{
		prof=(int*)list_get(proflist,i);
		sprintf(p,"%i %n",prof[0],&c);
		p+=c;
	}
	return(str);
}

char * media_desc_port_2char(MediaDesc *md)
{
	char *str;
	str=smalloc(6);
	sprintf(str,"%i",md->loc_port);
	return(str);
}
	
void media_desc_destroy(MediaDesc *md)
{
	/*
	for(pos=0;pos<md->profile_list->nb_elt;pos++)
	{
		el=list_get(md->profile_list,pos);
		if (el!=NULL) sfree(el);
	} */
	listofchar_free(md->profile_list);
	sfree(md);
}


