/*
  The osipua library is a library based on oSIP that implements CallLeg and User Agent
  level.
  Copyright (C) 2001  Simon MORLAT simon.morlat@free.fr
  											Aymeric MOIZARD jack@atosc.org
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MEDIADESC_H
#define MEDIADESC_H

#define STREAM_AUDIO 0
#define STREAM_VIDEO 1

#include <osip/sdp.h>

/* this object is used to represent media streams used by user agent*/
typedef struct _MediaDesc
{
	int type;  /*can be STREAM_AUDIO or STREAM_VIDEO*/
	list_t *profile_list;
	int loc_port;    /* local rtp port*/
	int rem_port;   /* remote rt port*/
	char *rem_ip4addr;  /*remote ip address*/
#define profile_1(m) ((int*)(m->profile_list->node->element))[0]
} MediaDesc;

/*constructor*/
MediaDesc *media_desc_new(int type);
MediaDesc *media_desc_new_from_char(char *list, int type);

void media_desc_append_profile(MediaDesc *md, int profile);

char * media_desc_profiles_2char(MediaDesc *md);

char * media_desc_port_2char(MediaDesc *md);

MediaDesc * media_desc_new_from_mediad(mediad_t *mediad);

/*destructor*/
void media_desc_destroy(MediaDesc *md);

#endif
